使用Gradle Application Plugin插件自动生成可执行.sh和.bat启动脚本
Posted jieniyimiao
tags:
篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了使用Gradle Application Plugin插件自动生成可执行.sh和.bat启动脚本相关的知识,希望对你有一定的参考价值。
1. 楔子
你还在使用手写的方式进行Java应用程序的打包吗?你还在使用手写shell和bat脚本的方式为JAVA应用程序写启动脚本吗?这些通用的、套路性质的、重复性质的工作早已在gradle Application Plugin
插件实现了,快来试试这个利器吧。
本文将演示两个常用的功能:
- 打包,tar或者zip包
- 自动生成启动脚本
1. 自动生成启动脚本
1.1 Demo下载
可以从GItHub上下载Demo
gradle Application Plugin
插件的官方地址为Application Plugin
1.2 build.gradle配置
首先新建一个ApplicationPlugin
的应用程序,代码如下:
package com.sino.daily.code_2020_6_25;
/**
* create by 2020-06-25 13:53
*
* @author caogu
*/
public class ApplicationPlugin
public static void main(String[] args)
System.out.println("Application Plugin Demo.");
System.out.println("https://docs.gradle.org/current/userguide/application_plugin.html");
在build.gradle
进行如下修改:添加application
插件; 配置main class
,例如
在settings.gradle
文件中配置工程的名字rootProject.name
。
1.3 生成脚本
最后执行gradle clean startScript
生成在windows和linux下可运行的通用启动脚本。
2 一键打包
使用gradle distZip
或gradle distTar
,可以自动生成上面的脚本、然后把应用程序打成一个可执行的ZIP包或者TAR包。
在windos下执行.bat即可运行该应用程序。
3 一键生成打包所需所有文件但不打包
执行gradle installDist
将在给定目录中准备脚本和可执行jar,但不打包它们。
4 Application Plugin插件介绍
Application
插件提供5个tasks实现项目的发布,分别是:
run
、startScript
、installApp
、distZip
、distTar
5 附录
自动生成java-daily-code
启动脚本内容:
#!/usr/bin/env sh
#
# Copyright 2015 the original author or authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
##############################################################################
##
## java-daily-code start up script for UN*X
##
##############################################################################
# Attempt to set APP_HOME
# Resolve links: $0 may be a link
PRG="$0"
# Need this for relative symlinks.
while [ -h "$PRG" ] ; do
ls=`ls -ld "$PRG"`
link=`expr "$ls" : '.*-> \\(.*\\)$'`
if expr "$link" : '/.*' > /dev/null; then
PRG="$link"
else
PRG=`dirname "$PRG"`"/$link"
fi
done
SAVED="`pwd`"
cd "`dirname \\"$PRG\\"`/.." >/dev/null
APP_HOME="`pwd -P`"
cd "$SAVED" >/dev/null
APP_NAME="java-daily-code"
APP_BASE_NAME=`basename "$0"`
# Add default JVM options here. You can also use JAVA_OPTS and JAVA_DAILY_CODE_OPTS to pass JVM options to this script.
DEFAULT_JVM_OPTS=""
# Use the maximum available, or set MAX_FD != -1 to use that value.
MAX_FD="maximum"
warn ()
echo "$*"
die ()
echo
echo "$*"
echo
exit 1
# OS specific support (must be 'true' or 'false').
cygwin=false
msys=false
darwin=false
nonstop=false
case "`uname`" in
CYGWIN* )
cygwin=true
;;
Darwin* )
darwin=true
;;
MINGW* )
msys=true
;;
NONSTOP* )
nonstop=true
;;
esac
CLASSPATH=$APP_HOME/lib/java-daily-code-0.0.1-SNAPSHOT.jar:$APP_HOME/lib/fastjson-1.2.47.jar:$APP_HOME/lib/joda-time-2.10.1.jar:$APP_HOME/lib/guava-27.0.1-jre.jar:$APP_HOME/lib/commons-lang3-3.8.1.jar:$APP_HOME/lib/commons-io-2.6.jar:$APP_HOME/lib/annotations-16.0.3.jar:$APP_HOME/lib/failureaccess-1.0.1.jar:$APP_HOME/lib/listenablefuture-9999.0-empty-to-avoid-conflict-with-guava.jar:$APP_HOME/lib/jsr305-3.0.2.jar:$APP_HOME/lib/checker-qual-2.5.2.jar:$APP_HOME/lib/error_prone_annotations-2.2.0.jar:$APP_HOME/lib/j2objc-annotations-1.1.jar:$APP_HOME/lib/animal-sniffer-annotations-1.17.jar
# Determine the Java command to use to start the JVM.
if [ -n "$JAVA_HOME" ] ; then
if [ -x "$JAVA_HOME/jre/sh/java" ] ; then
# IBM's JDK on AIX uses strange locations for the executables
JAVACMD="$JAVA_HOME/jre/sh/java"
else
JAVACMD="$JAVA_HOME/bin/java"
fi
if [ ! -x "$JAVACMD" ] ; then
die "ERROR: JAVA_HOME is set to an invalid directory: $JAVA_HOME
Please set the JAVA_HOME variable in your environment to match the
location of your Java installation."
fi
else
JAVACMD="java"
which java >/dev/null 2>&1 || die "ERROR: JAVA_HOME is not set and no 'java' command could be found in your PATH.
Please set the JAVA_HOME variable in your environment to match the
location of your Java installation."
fi
# Increase the maximum file descriptors if we can.
if [ "$cygwin" = "false" -a "$darwin" = "false" -a "$nonstop" = "false" ] ; then
MAX_FD_LIMIT=`ulimit -H -n`
if [ $? -eq 0 ] ; then
if [ "$MAX_FD" = "maximum" -o "$MAX_FD" = "max" ] ; then
MAX_FD="$MAX_FD_LIMIT"
fi
ulimit -n $MAX_FD
if [ $? -ne 0 ] ; then
warn "Could not set maximum file descriptor limit: $MAX_FD"
fi
else
warn "Could not query maximum file descriptor limit: $MAX_FD_LIMIT"
fi
fi
# For Darwin, add options to specify how the application appears in the dock
if $darwin; then
GRADLE_OPTS="$GRADLE_OPTS \\"-Xdock:name=$APP_NAME\\" \\"-Xdock:icon=$APP_HOME/media/gradle.icns\\""
fi
# For Cygwin or MSYS, switch paths to Windows format before running java
if [ "$cygwin" = "true" -o "$msys" = "true" ] ; then
APP_HOME=`cygpath --path --mixed "$APP_HOME"`
CLASSPATH=`cygpath --path --mixed "$CLASSPATH"`
JAVACMD=`cygpath --unix "$JAVACMD"`
# We build the pattern for arguments to be converted via cygpath
ROOTDIRSRAW=`find -L / -maxdepth 1 -mindepth 1 -type d 2>/dev/null`
SEP=""
for dir in $ROOTDIRSRAW ; do
ROOTDIRS="$ROOTDIRS$SEP$dir"
SEP="|"
done
OURCYGPATTERN="(^($ROOTDIRS))"
# Add a user-defined pattern to the cygpath arguments
if [ "$GRADLE_CYGPATTERN" != "" ] ; then
OURCYGPATTERN="$OURCYGPATTERN|($GRADLE_CYGPATTERN)"
fi
# Now convert the arguments - kludge to limit ourselves to /bin/sh
i=0
for arg in "$@" ; do
CHECK=`echo "$arg"|egrep -c "$OURCYGPATTERN" -`
CHECK2=`echo "$arg"|egrep -c "^-"` ### Determine if an option
if [ $CHECK -ne 0 ] && [ $CHECK2 -eq 0 ] ; then ### Added a condition
eval `echo args$i`=`cygpath --path --ignore --mixed "$arg"`
else
eval `echo args$i`="\\"$arg\\""
fi
i=$((i+1))
done
case $i in
(0) set -- ;;
(1) set -- "$args0" ;;
(2) set -- "$args0" "$args1" ;;
(3) set -- "$args0" "$args1" "$args2" ;;
(4) set -- "$args0" "$args1" "$args2" "$args3" ;;
(5) set -- "$args0" "$args1" "$args2" "$args3" "$args4" ;;
(6) set -- "$args0" "$args1" "$args2" "$args3" "$args4" "$args5" ;;
(7) set -- "$args0" "$args1" "$args2" "$args3" "$args4" "$args5" "$args6" ;;
(8) set -- "$args0" "$args1" "$args2" "$args3" "$args4" "$args5" "$args6" "$args7" ;;
(9) set -- "$args0" "$args1" "$args2" "$args3" "$args4" "$args5" "$args6" "$args7" "$args8" ;;
esac
fi
# Escape application args
save ()
for i do printf %s\\\\n "$i" | sed "s/'/'\\\\\\\\''/g;1s/^/'/;\\$s/\\$/' \\\\\\\\/" ; done
echo " "
APP_ARGS=$(save "$@")
# Collect all arguments for the java command, following the shell quoting and substitution rules
eval set -- $DEFAULT_JVM_OPTS $JAVA_OPTS $JAVA_DAILY_CODE_OPTS -classpath "\\"$CLASSPATH\\"" com.sino.daily.code_2020_6_25.ApplicationPlugin "$APP_ARGS"
# by default we should be in the correct project dir, but when run from Finder on Mac, the cwd is wrong
if [ "$(uname)" = "Darwin" ] && [ "$HOME" = "$PWD" ]; then
cd "$(dirname "$0")"
fi
exec "$JAVACMD" "$@"
以上是关于使用Gradle Application Plugin插件自动生成可执行.sh和.bat启动脚本的主要内容,如果未能解决你的问题,请参考以下文章
无法集成测试 gradle 多模块 Spring-Boot-Application
如何在 Eclipse 下用 Gradle 构建 Web Application